/**
 * SrbnFreaks(SOROBAN FREAKS)
 * (c) Kenta Cho (cs8k-cyu@asahi-net.or.jp)
 * http://www.asahi-net.or.jp/~cs8k-cyu/
 *
 * gamemanager.c(manage game status)
 */

static long gameStartSecond;
static int score, scad;

static void drawTitle() {
  gameStatus.waitTick = 0;
  gameStatus.status = TITLE;
  gameStatus.questionCnd = NONE;
  FrmGotoForm(TITLE_FORM);
}

static void initGame() {
  score = -1;
  drawTitle();
}

#define PRO_MODE 0
#define AMA_MODE 1
int gameMode;
long questionStartTick;

static void startButtonPushed(int gm) {
  gameStartSecond = TimGetSeconds();
  gameStatus.status = GAME_IN_PROGRESS;
  gameStatus.questionCnd = NONE;
  gameMode = gm;
  FrmGotoForm(SOROBAN_FORM);
}

static void startGame() {
  score = 0;
  gameStatus.questionCnd = GOTO_START;
}

char rkMsg[8][4] = {"E", "D", "C", "B", "A", "S", "SS", "SSS"};

static void drawResult() {
  char scStr[11] = "score ";
  char nmStr[4];
  char rkStr[11] = "rank ";
  int rank;
  WinDrawChars("GAME OVER", 9, 60, 70);
  StrIToA(nmStr, score);
  StrCat(scStr, nmStr);
  WinDrawChars(scStr, StrLen(scStr), 20, 85);
  rank = score/12;
  if ( rank > 7 ) rank = 7;
  StrCat(rkStr, rkMsg[rank]);
  WinDrawChars(rkStr, StrLen(rkStr), 110, 85);
}

/**
 * set wait interval(ticks)
 */
static void setWaitTick(long interval) {
  gameStatus.waitTick = TimGetTicks() + interval;
}

/**
 * draw status message
 */
static void drawMessage(char *msg) {
  RectangleType rct;
  rct.topLeft.x = 0;
  rct.topLeft.y = 150;
  rct.extent.x = 160;
  rct.extent.y = 10;
  WinEraseRectangle(&rct, 0);
  WinDrawChars(msg, StrLen(msg), 0, 150);
}

static void gameover() {
  setWaitTick(300);
  gameStatus.status = GOTO_TITLE;
}

/**
 * reset total
 */
static void initQuestion() { 
  total = 0;
}

static char ennari[] = {"~Ȃ"};
static char endewa[] = {"~ł"};

/**
 * make and draw question
 */
static void makeQuestion() {
  char msg[11], nmbStr[5];
  int rn;
  if ( randN(4)>0 ) {
    rn = randN(99)+1;
    scad = 2;
  } else {
    rn = randN(999)+1;
    scad = 3;
  }
  StrIToA(msg, rn);
  total += rn;
  if ( randN(16) == 0 || total > 8000 ) {
    StrCat(msg, endewa);
    gameStatus.questionCnd = LAST_QUESTION;
  } else {
    StrCat(msg, ennari);
    gameStatus.questionCnd = QUESTION;
  }
  if ( gameMode == PRO_MODE ) {
    questionStartTick = TimGetTicks();
    indicatorOn = FALSE;
  } else {
    indicatorOn = TRUE;
  }
  drawMessage(msg);
}

/**
 * check if soroban status is equal to total
 */
static void checkTotal() {
  int i;
  for ( i=0 ; i<SOROBAN_LINE_NMB ; i++ ) {
    SorobanLine sbl = sl[i];
    if ( sbl.topIdx != sbl.idTopIdx || sbl.btmIdx != sbl.idBtmIdx ) {
      return;
    }
  }
  score += scad;
  if ( gameStatus.questionCnd == LAST_QUESTION ) {
    gameStatus.questionCnd = GOTO_START;
  } else {
    gameStatus.questionCnd = NEXT_QUESTION;
  }
}

// game limit time(seconds)
#define GAME_TIME_SECONDS 60
// time until indicator turns on(ticks)
#define INDICATOR_TURNS_ON_TICKS 400

static char negaimasiteha[] = "˂܂Ă";
static char goMsg[] = "͂܂";

static void handleGameStatus() {
  if ( gameStatus.status == GAME_IN_PROGRESS &&
       TimGetSeconds() > (gameStartSecond+GAME_TIME_SECONDS) ) {
    drawMessage(goMsg);
    gameover();
  }
  if ( gameStatus.waitTick > 0 ) {
    if ( TimGetTicks() < gameStatus.waitTick ) return;
    gameStatus.waitTick = 0;
  }
  if ( gameStatus.status == GOTO_TITLE ) {
    clearSoroban();
    drawTitle();
    return;
  }
  switch ( gameStatus.questionCnd ) {
  case GOTO_START:
    initSoroban();
    repaintSoroban();
    drawMessage(negaimasiteha);
    drawStartIndicator();
    gameStatus.questionCnd = START;
    break;
  case GOTO_QUESTION:
    clearStartIndicator();
    initQuestion();
  case NEXT_QUESTION:
    makeQuestion();
    drawIndicator();
    break;
  case QUESTION:
  case LAST_QUESTION:
    if ( !indicatorOn && 
	TimGetTicks() > questionStartTick+INDICATOR_TURNS_ON_TICKS ) {
      indicatorOn = TRUE;
      drawIndicator();
    }
    break;
  }
}

